#!/bin/bash

CLI_NETEM_ARGS="delay 1ms"
CLI_LEAF_QDISC="cake"
#CLI_LEAF_QDISC="pfifo"
#CLI_LEAF_QDISC="sfq"
#CLI_LEAF_QDISC="fq_codel"
#CLI_LEAF_QDISC=""

SRV_NETEM_ARGS="delay 1ms"
SRV_LEAF_QDISC="cake"
#SRV_LEAF_QDISC="pfifo"
#SRV_LEAF_QDISC="sfq"
#SRV_LEAF_QDISC="fq_codel"
#SRV_LEAF_QDISC=""

# exit on error
set -e

# set up server
echo -e "----- server (namespace srv):\n"
ip netns add srv
ip link add seth0 type veth peer name ceth0
ip link set dev seth0 netns srv
ip netns exec srv ip link set seth0 up
ip netns exec srv ip addr add 10.12.0.1/24 dev seth0
ip netns exec srv tc qdisc add dev seth0 root handle 1: netem $SRV_NETEM_ARGS
if [ "$SRV_LEAF_QDISC" != "" ]; then
	ip netns exec srv tc qdisc add dev seth0 parent 1: $SRV_LEAF_QDISC
fi
ip netns exec srv ip link set lo up
ip netns exec srv ip addr

# set up client
echo -e "\n----- client (namespace cli):\n"
ip netns add cli
ip link set dev ceth0 netns cli
ip netns exec cli ip link set ceth0 up
ip netns exec cli ip addr add 10.12.0.2/24 dev ceth0
ip netns exec cli tc qdisc add dev ceth0 root handle 1: netem $CLI_NETEM_ARGS
if [ "$CLI_LEAF_QDISC" != "" ]; then
	ip netns exec cli tc qdisc add dev ceth0 parent 1: $CLI_LEAF_QDISC
fi
ip netns exec cli ip link set lo up
ip netns exec cli ip addr
